import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.time.*;

public class Stage2 {
    public static void main(String[] args) {
        ///////////// the cards will eventually atributes of a person
        TUI tarjeta1 = new TUI("Pablo", 1, 1868945);
        ///////////// the database managers are the ones that can make changes to a database file
        databaseManager TUI_database = new databaseManager("bases de datos/TUI dataBase");
        databaseManager entranceDatabase = new databaseManager("bases de datos/entrances database");
        databaseManager courtDatabase = new databaseManager("bases de datos/court rent database");
        databaseManager debtDatabase = new databaseManager("bases de datos/debts database");
        ///////////// here we have a person that does not do anything impressive... yet
        person persona1 = new person("Pablo", 21, 9, 1994);
        ///////////// here are some buildings. note that every entrance gets the same databaseManager entranceDatabase
        entrance placeres = new entrance("Placeres",1,1,entranceDatabase);
        entrance portales = new entrance("Portales",1,1,entranceDatabase);
        entrance espania = new entrance("Espania",1,1,entranceDatabase);
        entrance valdes = new entrance("Valdes",1,1,entranceDatabase);
        bank caja = new bank("caja", 1, 1, debtDatabase);
        courtsOffice torre = new courtsOffice("Torre", 1, 1, courtDatabase, false, false, false, caja);

        ///////////// the main purpose of all what follows here is to test the methods, some will print, some will write on a text file
        System.out.println(tarjeta1.getName()); 
        System.out.println(tarjeta1.getID());
        System.out.println(tarjeta1.getRank());
        System.out.println(persona1.Edad(LocalDateTime.now()));
        System.out.println(TUI_database.lookForID("1689685"));

        for (int i=0;i<5;i++) System.out.println("  " + TUI_database.pullInfo("1689685")[i]);  // prints all Peter's info
        TUI_database.pushInfo(new String[] {"1689685","Peter Languila","peter.languila@sansano.usm.cl","8498","4669.15"}); // changes Peter's priority
        TUI_database.pushInfo(new String[] {"1683285","Chimuelo Zafrada","chimuelo.zafrada@sansano.usm.cl","4298","5111.86"});  // creates a new student with an ID in between of the existent ones
        System.out.println("  ---------------");
        
        for (int i=0;i<5;i++) System.out.println("  " + TUI_database.pullInfo("1683285")[i]);
        TUI_database.deleteInfo("1683285");  // removes the previously added student
        valdes.registerEntryOrExit(LocalDateTime.now(), TUI_database.pullInfo("1689685")[1], "1689685");
        placeres.registerEntryOrExit(LocalDateTime.now(), TUI_database.pullInfo("1587627")[1], "1587627");
        torre.reservateCourt(LocalDateTime.now(), "c5x5", TUI_database.pullInfo("1689685")[1], "1689685", "02:00-11/07/2019");
        torre.reservateCourt(LocalDateTime.now(), "c7x7", TUI_database.pullInfo("1689685")[1], "1689685", "18:00-11/07/2019");
        torre.markAsistence("1689685", LocalDateTime.now(), 0, 1500);
        espania.registerEntryOrExit(LocalDateTime.now(), TUI_database.pullInfo("1689685")[1], "1689685");
    }
}