import java.time.*;

public class entrance extends structModel{
    /////////////////////////////// Inicializators    
    public entrance(String nombre,float pos_x,float pos_y, databaseManager baseDeDatos){
        super(nombre,pos_x,pos_y,baseDeDatos);      
    }
    
    /////////////////////////////// Methods
    public void registerEntryOrExit(LocalDateTime now, String name, String ID){
        String codeID = "";
        String formattedDate = "";
        String direction;
        int[] previousTimes;
        int lastTime;

        //the following code will create a chronological ID, usefull for sort purposes (this was created before databaseManager.appendInfo())
        codeID = codeID + String.valueOf(now.getYear()); 
        if (now.getMonthValue()<10) codeID = codeID + "0";
        codeID = codeID + String.valueOf(now.getMonthValue());
        if (now.getDayOfMonth()<10) codeID = codeID + "0";
        codeID = codeID + String.valueOf(now.getDayOfMonth());
        if (now.getHour()<10) codeID = codeID + "0";
        codeID = codeID + String.valueOf(now.getHour());
        if (now.getMinute()<10) codeID = codeID + "0";
        codeID = codeID + String.valueOf(now.getMinute());
        if (now.getSecond()<10) codeID = codeID + "0";
        codeID = codeID + String.valueOf(now.getSecond());
        if (now.getNano()/100000<10) codeID = codeID + "0";
        if (now.getNano()/100000<100) codeID = codeID + "0";
        if (now.getNano()/100000<1000) codeID = codeID + "0";
        codeID = codeID + String.valueOf(now.getNano()/100000);

        //the following code will create a formatted version of an hour, that will look like this: hh:mm-dd/mm/aaaa
        if (now.getHour()<10) formattedDate = formattedDate + "0";
        formattedDate = formattedDate + String.valueOf(now.getHour()) + ":";
        if (now.getMinute()<10) formattedDate = formattedDate + "0";
        formattedDate = formattedDate + String.valueOf(now.getMinute()) + ":";
        if (now.getDayOfMonth()<10) formattedDate = formattedDate + "0";
        formattedDate = formattedDate + String.valueOf(now.getDayOfMonth())+ "/";
        if (now.getMonthValue()<10) formattedDate = formattedDate + "0";
        formattedDate = formattedDate + String.valueOf(now.getMonthValue())+ "/";
        formattedDate = formattedDate + String.valueOf(now.getYear());

        // next code looks for the user's ID in the database to know if the user is inside or outside the campus. If no data, it assumes it's outside.
        previousTimes = this.database.lookForID(ID, 5);
        if (previousTimes.length != 0){
            lastTime = previousTimes[previousTimes.length-1];
            if(this.database.pullInfo(lastTime)[2].equals("Enter")) direction = "Exit";
            else direction = "Enter";
        }
        else direction = "Enter";
        this.database.pushInfo(new String[] {codeID, this.name, direction, formattedDate, name, ID});
    }
}