import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;
//import jdk.jfr.SettingControl;

class MainScreen extends JFrame implements ActionListener{
    private JLabel lblTitulo;

    private JButton button_Mainmenu1, button_Mainmenu2, button_Mainmenu3;
    private JButton button_WebLog1, button_WebLog2, button_WebLog3, button_Reg, button_RegBack;
    private JButton button_SimLog1, button_SimLog2, button_SimLog3;
    private JButton button_Web1, button_Web2, button_Web3, button_Web4;
    private JButton button_simPortales_in, button_simPlaceres_in, button_simValdes_in, button_SimEspania_in,button_SimAtras_in;
    private JButton button_simPortales_out, button_simPlaceres_out, button_simValdes_out, button_SimEspania_out,button_SimAtras_out;
    private JButton button_7x7, button_5x5, button_cp;

    private JLayeredPane layeredPane;
    private ImagePanel panel1,panel2,panel3,panel4,panel5,panel6,panel7,panel8;
    private ImagePanel[] paneles;

    public JTextField textInput_LogIn;
    public JTextField textInput_Register1,textInput_Register2,textInput_Register3;

    private MachineState status = MachineState.MAIN;
    private MachineState previous = MachineState.MAIN;

    private boolean validInput = false;

    String input;
    String[] output = new String[3];

     boolean[] flags = new boolean[] {false, false}; // {pagarDeuda, ArrendarCancha}

    /////////////////////////////// Inicializators    
    public MainScreen(){
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        setSize(1024,576);
        setTitle("Proyecto ELO-329");
        setLayout(null);
        setLocationRelativeTo(null);
        initializeMainWindowComponents();

    }
    
    /////////////////////////////// Methods
    public boolean getFlag(int index){
        return flags[index];
    }

    public void resetFlag(int index){
        flags[index] = false;
    }

    public void sendPopup(String message){
        String option = JOptionPane.showInputDialog(this.getParent(), message , null);
    }

    public void setVisiblePanel(String name){
        for (ImagePanel panel:paneles){
            if (panel.getName().equals(name)){
                panel.setVisible(true);
            }
            else{
                panel.setVisible(false);
            }
        }
    }

    public MachineState getStatus(){
        return status;
    }

    public void validateInput(boolean valid){
        validInput = valid;
    }
    public String getInput(){
        String input2 = input;
        input = "";
        return input2;
    }
    

    //////////////////////////////////////////////////////////////////// Action Listener
    /**
     * @return void: this method manages the Action events
     */
    public void actionPerformed(ActionEvent e){
        /////////////////////////////////////////// MainMenu
        if (e.getSource().equals(button_Mainmenu1)){
            previous = status;
            status = MachineState.WEBLOG;
        }
        if (e.getSource().equals(button_Mainmenu2)){
            previous = status;
            status = MachineState.SIMLOG;
        }
        if (e.getSource().equals(button_Mainmenu3)){
            previous = status;
            status = MachineState.EXIT;
        }
        /////////////////////////////////////////// WebLogMenu
        if (e.getSource().equals(button_WebLog1)){
            previous = status;
            status = MachineState.LOGIN;
        }
        if (e.getSource().equals(button_WebLog2)){
            previous = status;
            status = MachineState.REGISTER;
        }
        if (e.getSource().equals(button_WebLog3)){
            previous = status;
            status = MachineState.MAIN;
        }
        /////////////////////////////////////////// SimLogMenu
        if (e.getSource().equals(button_SimLog1)){
            previous = status;
            status = MachineState.LOGIN;
        }
        if (e.getSource().equals(button_SimLog2)){
            previous = status;
            status = MachineState.REGISTER;
        }
        if (e.getSource().equals(button_SimLog3)){
            previous = status;
            status = MachineState.MAIN;
        }
        /////////////////////////////////////////// LogMenu
        if (e.getSource().equals(textInput_LogIn)){
            input = textInput_LogIn.getText();
            textInput_LogIn.setText("");
            StateMachineController.LogIN("1");

            if (validInput){
                validInput = false;
                if (previous.equals(MachineState.WEBLOG)){
                    previous = status;
                    status = MachineState.WEB;
                }
                else if (previous.equals(MachineState.SIMLOG)){
                    previous = status;
                    status = MachineState.SIMOUTSIDE;
                }
            }
            else{
                if (previous.equals(MachineState.WEBLOG)){
                    previous = status;
                    status = MachineState.WEBLOG;
                }
                else if (previous.equals(MachineState.SIMLOG)){
                    previous = status;
                    status = MachineState.SIMLOG;
                }                
            }
        }
        /////////////////////////////////////////// RegMenu
        if (e.getSource().equals(button_Reg)){
            output[0] = textInput_Register1.getText();
            output[1] = textInput_Register2.getText();
            output[2] = textInput_Register3.getText();
            textInput_Register1.setText("");
            textInput_Register2.setText("");
            textInput_Register3.setText("");
            StateMachineController.Register(output);


            if (validInput){
                validInput = false;
                if (previous.equals(MachineState.WEBLOG)){
                    previous = status;
                    status = MachineState.WEBLOG;
                }
                else if (previous.equals(MachineState.SIMLOG)){
                    previous = status;
                    status = MachineState.SIMLOG;
                }
                else{System.out.println("ERROR-2");}
            }
            else{
                if (previous.equals(MachineState.WEBLOG)){
                    previous = status;
                    status = MachineState.WEBLOG;
                }
                else if (previous.equals(MachineState.SIMLOG)){
                    previous = status;
                    status = MachineState.SIMLOG;
                }
                else{System.out.println("ERROR-2");}                
            }
        }
        
        if (e.getSource().equals(button_RegBack)){
            if (previous.equals(MachineState.WEBLOG)){
                previous = status;
                status = MachineState.WEBLOG;
            }
            if (previous.equals(MachineState.SIMLOG)){
                previous = status;
                status = MachineState.SIMLOG;
            }
        }
        /////////////////////////////////////////// WebMenu
        if (e.getSource().equals(button_Web1)){
            System.out.println("Pagar");
            flags[0] = true; // {pagarDeuda, ArrendarCancha}
            //while (flags[0]){
            //}

        }
        if (e.getSource().equals(button_Web2)){
            System.out.println("Reservar");
        }
        if (e.getSource().equals(button_Web3)){
            System.out.println("Horas");
        }
        if (e.getSource().equals(button_Web4)){
            previous = status;
            status = MachineState.WEBLOG;
        }
        /////////////////////////////////////////// Sim menu out

        if (e.getSource().equals(button_simPortales_out)){
            previous = status;
            status = MachineState.SIMINSIDE;
        }
        if (e.getSource().equals(button_simPlaceres_out)){
            status = MachineState.SIMINSIDE;
        }
        if (e.getSource().equals(button_simValdes_out)){
            status = MachineState.SIMINSIDE;
        }
        if (e.getSource().equals(button_SimEspania_out)){
            status = MachineState.SIMINSIDE;
        }
        if (e.getSource().equals(button_SimAtras_out)){
            previous = status;
            status = MachineState.SIMLOG;
        }
        /////////////////////////////////////////// Sim menu in

        if (e.getSource().equals(button_simPortales_in)){
            previous = status;
            status = MachineState.SIMOUTSIDE;
        }
        if (e.getSource().equals(button_simPlaceres_in)){
            status = MachineState.SIMOUTSIDE;
        }
        if (e.getSource().equals(button_simValdes_in)){
            status = MachineState.SIMOUTSIDE;
        }
        if (e.getSource().equals(button_SimEspania_in)){
            status = MachineState.SIMOUTSIDE;
        }
        if (e.getSource().equals(button_SimAtras_in)){
            previous = status;
            status = MachineState.SIMLOG;
        }
    }

    //////////////////////////////////////////////////////////////////// Component Initializers

    /**
     * @return void: this method initializes the components of the main window
     */
    public void initializeMainWindowComponents(){
        layeredPane = new JLayeredPane();
        layeredPane.setBackground(Color.GREEN);
        layeredPane.setLayout(null);
        layeredPane.setBounds(0,0,1024,576);
        layeredPane.setVisible(true);

        add(layeredPane);
        initializeLayeredPaneComponents();
    }

    /**
     * @return void: this method initializes the components of the layered panel
     */
    public void initializeLayeredPaneComponents(){
        panel1 = new ImagePanel("imagenes/Principal.png","Main menu");
        panel1.setLayout(null);
        panel1.setBounds(0,0,1024,576);
        panel1.setVisible(true);

        panel2 = new ImagePanel("imagenes/webLog.png","WebLogMenu");
        panel2.setLayout(null);
        panel2.setBounds(0,0,1024,576);
        panel2.setVisible(false);

        panel3 = new ImagePanel("imagenes/simLog.png","SimLogMenu");
        panel3.setLayout(null);
        panel3.setBounds(0,0,1024,576);
        panel3.setVisible(false);

        panel4 = new ImagePanel("imagenes/Log1.png","Log in");
        panel4.setLayout(null);
        panel4.setBounds(0,0,1024,576);
        panel4.setVisible(false);

        panel5 = new ImagePanel("imagenes/Reg.png","Register");
        panel5.setLayout(null);
        panel5.setBounds(0,0,1024,576);
        panel5.setVisible(false);

        panel6 = new ImagePanel("imagenes/Log.png","Web");
        panel6.setLayout(null);
        panel6.setBounds(0,0,1024,576);
        panel6.setVisible(false);

        panel7 = new ImagePanel("imagenes/Ufuera1.png","SimulationOut");
        panel7.setLayout(null);
        panel7.setBounds(0,0,1024,576);
        panel7.setVisible(false);

        panel8 = new ImagePanel("imagenes/Udentro1.png","SimulationIn");
        panel8.setLayout(null);
        panel8.setBounds(0,0,1024,576);
        panel8.setVisible(false);
        
        layeredPane.add(panel1,new Integer(1));
        initializePanel1Components();
        layeredPane.add(panel2,new Integer(2)); // el mas grande esta encima
        initializePanel2Components();
        layeredPane.add(panel3,new Integer(3)); // el mas grande esta encima
        initializePanel3Components();
        layeredPane.add(panel4,new Integer(4)); // el mas grande esta encima
        initializePanel4Components();
        layeredPane.add(panel5,new Integer(5)); // el mas grande esta encima
        initializePanel5Components();
        layeredPane.add(panel6,new Integer(6)); // el mas grande esta encima
        initializePanel6Components();
        layeredPane.add(panel7,new Integer(7)); // el mas grande esta encima
        initializePanel7Components();
        layeredPane.add(panel8,new Integer(8)); // el mas grande esta encima
        initializePanel8Components();

        paneles = new ImagePanel[] {panel1,panel2,panel3,panel4,panel5,panel6,panel7,panel8};
    }

    /**
     * @return void: this method initializes the components of the panel 1 // Main menu
     */
    public void initializePanel1Components(){
        button_Mainmenu1 = new JButton("Entrar al servidor web");
        button_Mainmenu1.setBounds(50,140,200,25);
        button_Mainmenu1.addActionListener(this);

        button_Mainmenu2 = new JButton("Simular un paseo por el campus");
        button_Mainmenu2.setBounds(50,180,200,25);
        button_Mainmenu2.addActionListener(this);

        button_Mainmenu3 = new JButton("Salir");
        button_Mainmenu3.setBounds(50,220,200,25);
        button_Mainmenu3.addActionListener(this);

        panel1.add(button_Mainmenu1);
        panel1.add(button_Mainmenu2);
        panel1.add(button_Mainmenu3);
    }

    /**
     * @return void: this method initializes the components of the panel 2 // WebLogMenu
     */
    public void initializePanel2Components(){

        button_WebLog1 = new JButton("Ingresar");
        button_WebLog1.setBounds(50,140,200,25);
        button_WebLog1.addActionListener(this);

        button_WebLog2 = new JButton("Registrarse");
        button_WebLog2.setBounds(50,180,200,25);
        button_WebLog2.addActionListener(this);

        button_WebLog3 = new JButton("Volver atras");
        button_WebLog3.setBounds(50,220,200,25);
        button_WebLog3.addActionListener(this);

        panel2.add(button_WebLog1);
        panel2.add(button_WebLog2);
        panel2.add(button_WebLog3);
    }

    /**
     * @return void: this method initializes the components of the panel 3 // SimLogMenu
     */
    public void initializePanel3Components(){

        button_SimLog1 = new JButton("Ingresar");
        button_SimLog1.setBounds(50,140,200,25);
        button_SimLog1.addActionListener(this);

        button_SimLog2 = new JButton("Registrarse");
        button_SimLog2.setBounds(50,180,200,25);
        button_SimLog2.addActionListener(this);

        button_SimLog3 = new JButton("Volver atras");
        button_SimLog3.setBounds(50,220,200,25);
        button_SimLog3.addActionListener(this);

        panel3.add(button_SimLog1);
        panel3.add(button_SimLog2);
        panel3.add(button_SimLog3);
    }

    /**
     * @return void: this method initializes the components of the panel 4 // Log in
     */
    public void initializePanel4Components(){
        textInput_LogIn = new JTextField();
        textInput_LogIn.setBounds(440, 260, 180, 25);
        textInput_LogIn.addActionListener(this);
        
        panel4.add(textInput_LogIn);

    }

    /**
     * @return void: this method initializes the components of the panel 5 // Register
     */
    public void initializePanel5Components(){

        textInput_Register1 = new JTextField();
        textInput_Register1.setBounds(250, 180, 300, 25);

        textInput_Register2 = new JTextField();
        textInput_Register2.setBounds(250, 240, 300, 25);

        textInput_Register3 = new JTextField();
        textInput_Register3.setBounds(250, 300, 300, 25);

        button_Reg = new JButton("Registrar");
        button_Reg.setBounds(250,400,200,25);
        button_Reg.addActionListener(this);

        button_RegBack = new JButton("Volver atras");
        button_RegBack.setBounds(600,400,200,25);
        button_RegBack.addActionListener(this);
        
        panel5.add(textInput_Register1);
        panel5.add(textInput_Register2);
        panel5.add(textInput_Register3);
        panel5.add(button_Reg);
        panel5.add(button_RegBack);
    }

    /**
     * @return void: this method initializes the components of the panel 6 // Web
     */
    public void initializePanel6Components(){

        button_Web1 = new JButton("Pagar Deuda");
        button_Web1.setBounds(250,140,200,25);
        button_Web1.addActionListener(this);

        button_Web2 = new JButton("Reservar Cancha");
        button_Web2.setBounds(250,180,200,25);
        button_Web2.addActionListener(this);

        button_Web3 = new JButton("Horas activo en el Campus");
        button_Web3.setBounds(250,220,200,25);
        button_Web3.addActionListener(this);

        button_Web4 = new JButton("Volver al Menu");
        button_Web4.setBounds(450,400,200,25);
        button_Web4.addActionListener(this);

        panel6.add(button_Web1);
        panel6.add(button_Web2);
        panel6.add(button_Web3);
        panel6.add(button_Web4);
    }

    /**
     * @return void: this method initializes the components of the panel 7 // SimulationOut
     */
    public void initializePanel7Components(){
        button_simPortales_out = new JButton();
        button_simPortales_out.setBounds(819,535,25,25);
        button_simPortales_out.addActionListener(this);

        button_simPlaceres_out = new JButton();
        button_simPlaceres_out.setBounds(374,535,25,25);
        button_simPlaceres_out.addActionListener(this);

        button_simValdes_out = new JButton();
        button_simValdes_out.setBounds(862,419,25,25);
        button_simValdes_out.addActionListener(this);

        button_SimEspania_out = new JButton();
        button_SimEspania_out.setBounds(512,79,25,25);
        button_SimEspania_out.addActionListener(this);

        button_SimAtras_out = new JButton("Volver atras");
        button_SimAtras_out.setBounds(800,10,200,25);
        button_SimAtras_out.addActionListener(this);

        panel7.add(button_simPortales_out);
        panel7.add(button_simPlaceres_out);
        panel7.add(button_simValdes_out);
        panel7.add(button_SimEspania_out);
        panel7.add(button_SimAtras_out);
    }

    /**
     * @return void: this method initializes the components of the panel 8 // SimulationIn
     */
    public void initializePanel8Components(){
        button_simPortales_in = new JButton();
        button_simPortales_in.setBounds(819,535,25,25);
        button_simPortales_in.addActionListener(this);

        button_simPlaceres_in = new JButton();
        button_simPlaceres_in.setBounds(374,535,25,25);
        button_simPlaceres_in.addActionListener(this);

        button_simValdes_in = new JButton();
        button_simValdes_in.setBounds(862,419,25,25);
        button_simValdes_in.addActionListener(this);

        button_SimEspania_in = new JButton();
        button_SimEspania_in.setBounds(512,79,25,25);
        button_SimEspania_in.addActionListener(this);

        button_SimAtras_in = new JButton("Volver atras");
        button_SimAtras_in.setBounds(800,10,200,25);
        button_SimAtras_in.addActionListener(this);

        button_5x5 = new JButton();
        button_5x5.setBounds(832,447,69,35);
        button_5x5.addActionListener(this);

        button_7x7 = new JButton();
        button_7x7.setBounds(512,79,25,25);
        button_7x7.addActionListener(this);

        button_cp = new JButton();
        button_cp.setBounds(665,210,126,201);
        button_cp.addActionListener(this);

        panel8.add(button_simPortales_in);
        panel8.add(button_simPlaceres_in);
        panel8.add(button_simValdes_in);
        panel8.add(button_SimEspania_in);
        panel8.add(button_SimAtras_in);
        panel8.add(button_5x5);
        panel8.add(button_7x7);
        panel8.add(button_cp);;
    }
}

class ImagePanel extends JPanel {

    private Image img;
    private String nombre;
  
    public ImagePanel(String img, String name) {
      this(new ImageIcon(img).getImage(),name);
    }

    public String getName(){
        return nombre;
    }
  
    public ImagePanel(Image img, String name) {
        nombre = name;
      this.img = img;
      Dimension size = new Dimension(img.getWidth(null), img.getHeight(null));
      setPreferredSize(size);
      setMinimumSize(size);
      setMaximumSize(size);
      setSize(size);
      setLayout(null);
    }
  
    public void paintComponent(Graphics g) {
      g.drawImage(img, 0, 0, null);
    }
}

