import java.awt.*;
import java.io.BufferedReader;
import java.io.IOException;
import java.util.StringTokenizer;
import javax.swing.*;


import java.util.*;
import java.time.*;

import java.util.Scanner;
import java.io.InputStreamReader;

public class Stage5 {
    public static void main(String[] args) throws IOException {
        MachineState status;
        BufferedReader keyboardInput;

        String input;
        String input_state = "";
        String insideWhileInput;
        String info;

        String mainMenuMessage = "\n";
        String webLogMenuMessage = "\n";
        String simulationLogMenuMessage = "\n";
        String webServicesMenuMessage = "\n";
        String simulationMenuMessage = "\n";
        String simulationMessageInsideCampus = "\n";
        String simulationLeavingCampusMenuMessage = "\n";
        String simulationSelectSportsCourtMessage = "\n";

        String horariosCancha = "\n";
        String diasSemana = "\n";

        boolean mainMenu;
        boolean paying;
        boolean renting;
        boolean simInsideTheCampus;

        boolean nextStage;

        person user = new person("",0,0,0);
        String userID = "";
        int key;
        String[] answer = new String[2];

        ///////////// the database managers are the ones that can make changes to a database file
        databaseManager TUI_database = new databaseManager("bases de datos/TUI dataBase");
        databaseManager entranceDatabase = new databaseManager("bases de datos/entrances database");
        databaseManager courtDatabase = new databaseManager("bases de datos/court rent database");
        databaseManager debtDatabase = new databaseManager("bases de datos/debts database");        
        ///////////// here are some buildings. note that every entrance gets the same databaseManager entranceDatabase
        bank caja = new bank("caja", 1, 1, debtDatabase, TUI_database);
        entrance placeres = new entrance("Placeres",1,1,entranceDatabase);
        entrance portales = new entrance("Portales",1,1,entranceDatabase);
        entrance espania = new entrance("Espania",1,1,entranceDatabase);
        entrance valdes = new entrance("Valdes",1,1,entranceDatabase);
        courtsOffice torre = new courtsOffice("Torre", 1, 1, courtDatabase, false, false, false, caja);
        ///////////// those are the messages that will be printed at the menus
        MainScreen ventanaPrincipal = new MainScreen();
        ventanaPrincipal.setVisible(true);

        StateMachineController controller = new StateMachineController(caja, placeres, portales, espania, valdes, torre, TUI_database, ventanaPrincipal);

        ////////////

        ///////////// this is the main menu
        controller.controlar();
    }
}

