import java.sql.DatabaseMetaData;
import java.sql.Date;
import java.time.*;

class structModel {
    /////////////////////////////// Parameters
    protected String name;
    protected float x_Coord;
    protected float y_Coord;
    protected databaseManager database;

    /////////////////////////////// Inicializators
    public structModel(String nombre,float pos_x,float pos_y, databaseManager baseDatos){
        this.name = nombre;
        this.x_Coord = pos_x;
        this.y_Coord = pos_y;   
        this.database = baseDatos;     
    }
    /////////////////////////////// Methods
    
    /**
     * @return String: This method returns the name of this instance
     */
    public String getBuildingsName() {
        return this.name;
    }

    /**
     * @return float[]: This method returns x,y coordenates of tis instance
     */
    public float[] getBuildingsPosition() {
        return new float[] {this.x_Coord,this.y_Coord};
    }

    /**
     * @return databaseManager: This method returns the databaseManager of this instance
     */
    public databaseManager getDatabaseManager() {
        return database;
    }
}