import java.util.Scanner;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

//public void actionPerformed(ActionEvent arg0) {}

public class databaseManager /*implements ActionListener*/{

    /////////////////////////////// Parameters
    private String filename;
    private Scanner file;

    /////////////////////////////// Inicializators
    public databaseManager(String nombreArchivo){
        this.filename = nombreArchivo;
    }
    /////////////////////////////// Methods
    public Boolean lookForID(String ID) {
        boolean isInThere = false;
        boolean open = false;
        boolean completelyReaded = false;
        while (!completelyReaded){
            try {
                if (!open){                                           // Esto es para que el documento se abra una sola vez
                    file = new Scanner(new File(filename));
                    open = true;
                    completelyReaded = false;
                    isInThere = false;
                }
                if (file.hasNextLine()) {                             // Cuando llega a la linea final se cierra
                    String line = file.nextLine();
                    String[] personalData = line.split("_");
                    if (ID.equals(personalData[0])){
                        isInThere = true;
                    }
                }
                else{
                    file.close();
                    open = false;
                    completelyReaded = true;
                }
            }
            catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        return isInThere;
    }

    public String[] pullInfo(String ID) {
        String[] personalData;
        boolean open = false;
        boolean completelyReaded = false;
        while (!completelyReaded){
            try {
                if (!open){                                                // Esto es para que el documento se abra una sola vez
                    file = new Scanner(new File(filename));
                    open = true;
                    completelyReaded = false;
                }
                if (file.hasNextLine()) {                                   // Cuando llega a la linea final se cierra
                    String line = file.nextLine();
                    personalData = line.split("_");
                    if (ID.equals(personalData[0])){
                        file.close();
                        return personalData;
                    }
                }
                else{
                    file.close();
                    open = false;
                    completelyReaded = true;
                }
            }
            catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        personalData = new String[] {""};
        return personalData;
    }

    public void pushInfo(String[] data) {
        String newFileData = "";
        String[] personalData;
        boolean open = false;
        boolean completelyReaded = false;
        boolean changeExcecuted = false;
        FileWriter writer = null;

        while (!completelyReaded){
            try {
                if (!open){                                                // Esto es para que el documento se abra una sola vez
                    file = new Scanner(new File(filename));
                    open = true;
                    completelyReaded = false;
                }
                if (file.hasNextLine()) {                                   // Cuando llega a la linea final se cierra
                    String line = file.nextLine();
                    personalData = line.split("_");
                    if (Long.parseLong(data[0]) > Long.parseLong(personalData[0]) && !changeExcecuted){
                        newFileData = newFileData + line + "\n";
                    }
                    if (Long.parseLong(data[0]) < Long.parseLong(personalData[0]) && !changeExcecuted){
                        newFileData = newFileData + String.join("_", data) + "\n";
                        changeExcecuted = true;
                    }
                    if (Long.parseLong(data[0]) == Long.parseLong(personalData[0]) && !changeExcecuted){
                        newFileData = newFileData + String.join("_", data) + "\n";
                        changeExcecuted = true;
                    }
                    else if (changeExcecuted){
                        newFileData = newFileData + line + "\n";
                    }
                }
                else{
                    file.close();
                    open = false;
                    completelyReaded = true;
                }
            }
            catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        try{
            writer = new FileWriter(filename);
            writer.write(newFileData);
            writer.close();
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public void deleteInfo(String ID) {
        String newFileData = "";
        String[] personalData;
        boolean open = false;
        boolean completelyReaded = false;
        boolean changeExcecuted = false;
        FileWriter writer = null;

        while (!completelyReaded){
            try {
                if (!open){                                                // Esto es para que el documento se abra una sola vez
                    file = new Scanner(new File(filename));
                    open = true;
                    completelyReaded = false;
                }
                if (file.hasNextLine()) {                                   // Cuando llega a la linea final se cierra
                    String line = file.nextLine();
                    personalData = line.split("_");
                    if (!ID.equals(personalData[0])){
                        newFileData = newFileData + line + "\n";
                    }
                }
                else{
                    file.close();
                    open = false;
                    completelyReaded = true;
                }
            }
            catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        try{
            writer = new FileWriter(filename);
            writer.write(newFileData);
            writer.close();
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
    }
}
