import java.awt.*;
import java.io.BufferedReader;
import java.io.IOException;
import java.util.StringTokenizer;
import javax.swing.*;


import java.util.*;
import java.time.*;

import java.util.Scanner;
import java.io.InputStreamReader;

public class Stage3 {
    public static void main(String[] args) throws IOException {
        BufferedReader keyboardInput;
        String input;
        String insideWhileInput;
        String info;

        String mainMenuMessage = "\n";
        String webLogMenuMessage = "\n";
        String simulationLogMenuMessage = "\n";
        String webMenuMessage = "\n";
        String webServicesMenuMessage = "\n";
        String simulationMenuMessage = "\n";
        String simulationMessageInsideCampus = "\n";
        String simulationLeavingCampusMenuMessage = "\n";
        String simulationSelectSportsCourtMessage = "\n";

        String horariosCancha = "\n";
        String diasSemana = "\n";

        boolean mainMenu;
        boolean webLogMenu;
        boolean webMenu;
        boolean paying;
        boolean renting;
        boolean simMenu;
        boolean simLogMenu;
        boolean simInsideTheCampus;

        boolean nextStage;

        person user;

        ///////////// the database managers are the ones that can make changes to a database file
        databaseManager TUI_database = new databaseManager("bases de datos/TUI dataBase");
        databaseManager entranceDatabase = new databaseManager("bases de datos/entrances database");
        databaseManager courtDatabase = new databaseManager("bases de datos/court rent database");
        databaseManager debtDatabase = new databaseManager("bases de datos/debts database");        
        ///////////// here are some buildings. note that every entrance gets the same databaseManager entranceDatabase
        bank caja = new bank("caja", 1, 1, debtDatabase, TUI_database);
        entrance placeres = new entrance("Placeres",1,1,entranceDatabase);
        entrance portales = new entrance("Portales",1,1,entranceDatabase);
        entrance espania = new entrance("Espania",1,1,entranceDatabase);
        entrance valdes = new entrance("Valdes",1,1,entranceDatabase);
        courtsOffice torre = new courtsOffice("Torre", 1, 1, courtDatabase, false, false, false, caja);
        ///////////// those are the messages that will be printed at the menus
        mainMenuMessage = mainMenuMessage + "Bienvenido al menu principal de la plataforma ELO-329\n";
        mainMenuMessage = mainMenuMessage + "Para seleccionar una opcion escriba su numero seguido de un enter.\n";
        mainMenuMessage = mainMenuMessage + "elija una opcion\n";
        mainMenuMessage = mainMenuMessage + "1 - Entrar al servicio web\n";
        mainMenuMessage = mainMenuMessage + "2 - Ir a la universidad\n";
        mainMenuMessage = mainMenuMessage + "3 - Salir\n";

        webLogMenuMessage = webLogMenuMessage + "Bienvenido al servidor web de la plataforma ELO-329\n";
        webLogMenuMessage = webLogMenuMessage + "elija una opcion\n";
        webLogMenuMessage = webLogMenuMessage + "1 - Iniciar sesion\n";
        webLogMenuMessage = webLogMenuMessage + "2 - Registarse\n";
        webLogMenuMessage = webLogMenuMessage + "3 - Volver al menu principal\n";

        webServicesMenuMessage = webServicesMenuMessage + "Ha entrado al servidor web exitosamente\n";
        webServicesMenuMessage = webServicesMenuMessage + "elija una opcion\n";
        webServicesMenuMessage = webServicesMenuMessage + "1 - Pagar una deuda\n";
        webServicesMenuMessage = webServicesMenuMessage + "2 - Reservar una cancha\n";
        webServicesMenuMessage = webServicesMenuMessage + "3 - Verificar horas invertidas en el campus este año\n";
        webServicesMenuMessage = webServicesMenuMessage + "4 - Cerrar sesion\n";

        simulationLogMenuMessage = simulationLogMenuMessage + "Bienvenido al menu de simulacion de la universidad de la plataforma ELO-329\n";
        simulationLogMenuMessage = simulationLogMenuMessage + "elija una opcion\n";
        simulationLogMenuMessage = simulationLogMenuMessage + "1 - Ingresar\n";
        simulationLogMenuMessage = simulationLogMenuMessage + "2 - Registrarse\n";
        simulationLogMenuMessage = simulationLogMenuMessage + "3 - Volver al menu principal\n";

        simulationMenuMessage = simulationMenuMessage + "Usted se encuentra fuera del campus\n";
        simulationMenuMessage = simulationMenuMessage + "elija una opcion\n";
        simulationMenuMessage = simulationMenuMessage + "1 - Entrar al campus via Placeres\n";
        simulationMenuMessage = simulationMenuMessage + "2 - Entrar al campus via Portales\n";
        simulationMenuMessage = simulationMenuMessage + "3 - Entrar al campus via Espania\n";
        simulationMenuMessage = simulationMenuMessage + "4 - Entrar al campus via Valdes\n";
        simulationMenuMessage = simulationMenuMessage + "5 - Volver al menu principal\n";

        simulationMessageInsideCampus = simulationMessageInsideCampus + "Uted se encuentra dentro del campus\n";
        simulationMessageInsideCampus = simulationMessageInsideCampus + "elija una opcion\n";
        simulationMessageInsideCampus = simulationMessageInsideCampus + "1 - Dirigirse hacia una cancha\n";
        simulationMessageInsideCampus = simulationMessageInsideCampus + "2 - Salir del campus\n";

        simulationLeavingCampusMenuMessage = simulationLeavingCampusMenuMessage + "Usted esta saliendo del campus\n";
        simulationLeavingCampusMenuMessage = simulationLeavingCampusMenuMessage + "elija una opcion\n";
        simulationLeavingCampusMenuMessage = simulationLeavingCampusMenuMessage + "1 - Salir del campus via Placeres\n";
        simulationLeavingCampusMenuMessage = simulationLeavingCampusMenuMessage + "2 - Salir del campus via Portales\n";
        simulationLeavingCampusMenuMessage = simulationLeavingCampusMenuMessage + "3 - Salir del campus via Valdes\n";
        simulationLeavingCampusMenuMessage = simulationLeavingCampusMenuMessage + "4 - Salir del campus via Espania\n";
        simulationLeavingCampusMenuMessage = simulationLeavingCampusMenuMessage + "5 - Cancel\n";

        simulationSelectSportsCourtMessage = simulationSelectSportsCourtMessage + "Usted se dirije a una cancha\n";
        simulationSelectSportsCourtMessage = simulationSelectSportsCourtMessage + "elija una opcion\n";
        simulationSelectSportsCourtMessage = simulationSelectSportsCourtMessage + "1 - Ir a la cancha 5x5\n";
        simulationSelectSportsCourtMessage = simulationSelectSportsCourtMessage + "2 - Ir a la cancha 7x7\n";
        simulationSelectSportsCourtMessage = simulationSelectSportsCourtMessage + "3 - Ir a la cancha de pasto\n";
        simulationSelectSportsCourtMessage = simulationSelectSportsCourtMessage + "4 - Cancel\n";

        /////////////////////////////////////////
        horariosCancha = horariosCancha + "01 - 08:00\n";
        horariosCancha = horariosCancha + "02 - 09:00\n";
        horariosCancha = horariosCancha + "03 - 10:00\n";
        horariosCancha = horariosCancha + "04 - 11:00\n";
        horariosCancha = horariosCancha + "05 - 12:00\n";
        horariosCancha = horariosCancha + "06 - 13:00\n";
        horariosCancha = horariosCancha + "07 - 14:00\n";
        horariosCancha = horariosCancha + "08 - 15:00\n";
        horariosCancha = horariosCancha + "09 - 16:00\n";
        horariosCancha = horariosCancha + "10 - 17:00\n";
        horariosCancha = horariosCancha + "11 - 18:00\n";
        horariosCancha = horariosCancha + "12 - 19:00\n";
        horariosCancha = horariosCancha + "13 - 20:00\n";
        horariosCancha = horariosCancha + "14 - No arrendar\n";

        diasSemana = diasSemana + "1 - Lunes\n";
        diasSemana = diasSemana + "2 - Martes\n";
        diasSemana = diasSemana + "3 - Miercoles\n";
        diasSemana = diasSemana + "4 - Jueves\n";
        diasSemana = diasSemana + "5 - Viernes\n";
        diasSemana = diasSemana + "6 - Sabado\n";

        ///////////// this is the main menu
        mainMenu = true;
        while (mainMenu){
            System.out.println(mainMenuMessage); 
            keyboardInput = new BufferedReader(new InputStreamReader(System.in));
            input = keyboardInput.readLine();
            while (!input.equals("1") && !input.equals("2") && !input.equals("3")){
                System.out.println("Por favor ingrese una opcion valida");
                keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                input = keyboardInput.readLine();
            }
            if (input.equals("1")){
                ///////////// this is the web page's menu
                webLogMenu = true;
                while (webLogMenu){
                    System.out.println(webLogMenuMessage); 
                    keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                    input = keyboardInput.readLine();
                    while (!input.equals("1") && !input.equals("2") && !input.equals("3")){
                        System.out.println("Por favor ingrese una opcion valida");
                        keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                        input = keyboardInput.readLine();
                    }
                    if (input.equals("1")){
                        ///////////// this is the web page's login
                        System.out.println("Ingrese su ID");
                        keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                        input = keyboardInput.readLine();
                        if (TUI_database.lookForID(input).length>0){
                            ///////////// if login is successful
                            System.out.println("Ha ingresado satisfactoriamente");
                            user = new person(TUI_database.pullInfo(input)[1],8,8,1994,5000,new TUI(TUI_database.pullInfo(input)[1], 1, Integer.valueOf(input)));
                            String userID = Integer.toString(user.getTUI().getID());
                            System.out.println("Bienvenido/a "+user.getName());
                            webMenu = true;
                            while (webMenu){
                                ///////////// the user can now access the different services of the web page
                                System.out.println(webServicesMenuMessage); 
                                keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                input = keyboardInput.readLine();            
                                while (!input.equals("1") && !input.equals("2") && !input.equals("3") && !input.equals("4")){
                                    System.out.println("Por favor ingrese una opcion valida");
                                    keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                    input = keyboardInput.readLine();
                                }
                                if (input.equals("1")){
                                    ///////////// the user wants to pay a debt
                                    ArrayList<String[]> debts = caja.getSomeonesDebts(userID);
                                    paying = true;
                                    while (paying){
                                        System.out.println("\nSu balance actual en su cuenta es de $"+caja.getSomeonesBalance(userID)+" pesos");
                                        int totalDebts = caja.printSomeonesDebts(userID);
                                        System.out.println(Integer.toString(totalDebts+1)+" Volver atras");
                                        System.out.println("\nElija a quien quiere pagar\n"); 
                                        keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                        input = keyboardInput.readLine();      
                                        while (!(Integer.valueOf(input)>0) || !(Integer.valueOf(input) <= debts.size()+1)){
                                            System.out.println("Por favor ingrese una opcion valida");
                                            keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                            input = keyboardInput.readLine();
                                        }
                                        int cont = 0;
                                        // This while cycle implements an indefinite version of the "select an option"
                                        while (cont <= debts.size()){
                                            if (Integer.toString(cont).equals(input)){
                                                System.out.println("Ingrese el monto que desea pagar a " + debts.get(cont-1)[0] + "\n"); 
                                                keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                                insideWhileInput = keyboardInput.readLine(); 
                                                caja.managePayment(Integer.toString(user.getTUI().getID()),debts.get(cont-1)[0], Integer.valueOf(insideWhileInput));
                                            }
                                            cont ++;
                                        }
                                        paying = false;
                                    }
                                }
                                else if (input.equals("2")){
                                    ///////////// the user wants to rent a court
                                    renting = true;
                                    while (renting){
                                        int totalcourts = torre.printCourts();
                                        System.out.println(Integer.toString(totalcourts+1)+" Volver atras");
                                        keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                        input = keyboardInput.readLine();      
                                        while (!(Integer.valueOf(input)>0) || !(Integer.valueOf(input) <= totalcourts+1)){
                                            System.out.println("Por favor ingrese una opcion valida");
                                            keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                            input = keyboardInput.readLine();
                                        }
                                        int cont = 0;
                                        // This while cycle implements an indefinite version of the "select an option"
                                        while (cont <= totalcourts){
                                            if (Integer.toString(cont).equals(input)){
                                                System.out.print("Elija el horario en que quiere reservar la cancha " + torre.getCourt(Integer.valueOf(input)-1));
                                                System.out.print(horariosCancha);
                                                keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                                insideWhileInput = keyboardInput.readLine();      
                                                while (Integer.valueOf(insideWhileInput)<0 || Integer.valueOf(insideWhileInput)>14){
                                                    System.out.println("Por favor ingrese una opcion valida");
                                                    keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                                    insideWhileInput = keyboardInput.readLine();
                                                }
                                                int hora = Integer.valueOf(insideWhileInput)+8;
                                                System.out.print("Elija el dia en que quiere reservar la cancha");
                                                System.out.print(diasSemana);
                                                System.out.print("7 - Cancelar\n");
                                                keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                                insideWhileInput = keyboardInput.readLine();      
                                                while (!insideWhileInput.equals("1") && !insideWhileInput.equals("2") && !insideWhileInput.equals("3") && !insideWhileInput.equals("4") && !insideWhileInput.equals("5") && !insideWhileInput.equals("6") && !insideWhileInput.equals("6")){
                                                    System.out.println("Por favor ingrese una opcion valida");
                                                    keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                                    insideWhileInput = keyboardInput.readLine();
                                                }
                                                int dia = Integer.valueOf(insideWhileInput);
                                                System.out.println(torre.getFormattedDate(LocalDateTime.now(), hora, dia));
                                                torre.reservateCourt(LocalDateTime.now(), torre.getCourt(cont-1), user.getName(), userID, torre.getFormattedDate(LocalDateTime.now(), hora, dia));
                                            }
                                            cont ++;
                                        }
                                        renting = false;
                                    }
                                }
                                else if (input.equals("3")){
                                    int horas = placeres.getHoursOnCampus(LocalDateTime.now(), userID);
                                    System.out.println("Usted ha invertido hasta ahora " + Integer.toString(horas) + " horas en el campus");
                                }
                                else if (input.equals("4")){
                                    webMenu = false;
                                    webLogMenu = false;
                                }

                            }
                        }
                        else System.out.println("Por favor ingrese un ID existente");
                    }
                    else if (input.equals("2")){info=Stage3.Register(1);
                        System.out.println(info); } ; 
                    if (input.equals("3")) webLogMenu = false;
                }
            }
            else if (input.equals("2")){
                ///////////// this is the simulation menu
                simLogMenu = true;
                while (simLogMenu){
                    System.out.println(simulationLogMenuMessage); 
                    keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                    input = keyboardInput.readLine();
                    while (!input.equals("1") && !input.equals("2") && !input.equals("3") && !input.equals("4") && !input.equals("5")){
                        System.out.println("Por favor ingrese una opcion valida");
                        keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                        input = keyboardInput.readLine();
                    }
                    if (input.equals("1")){
                        ///////////// this is the web page's login
                        System.out.println("Ingrese su ID");
                        keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                        input = keyboardInput.readLine();
                        if (TUI_database.lookForID(input).length>0){
                            ///////////// if login is successful
                            System.out.println("Ha ingresado satisfactoriamente");
                            user = new person(TUI_database.pullInfo(input)[1],8,8,1994,5000,new TUI(TUI_database.pullInfo(input)[1], 1, Integer.valueOf(input)));
                            System.out.println("Bienvenido/a "+user.getName());
                            simMenu = true;
                            while (simMenu){
                                ///////////// the simulations starts, the student is outside the campus
                                System.out.println(simulationMenuMessage);
                                keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                input = keyboardInput.readLine();
                                nextStage = false;
                                while (!input.equals("1") && !input.equals("2") && !input.equals("3") && !input.equals("4") && !input.equals("5")){
                                    System.out.println("Por favor ingrese una opcion valida");
                                    keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                    input = keyboardInput.readLine();
                                }
                                if (input.equals("1")){
                                    placeres.registerEntryOrExit(LocalDateTime.now(), String.valueOf(user.getTUI().getID()),user.getTUI().getName());
                                    nextStage = true;
                                }
                                else if (input.equals("2")){
                                    portales.registerEntryOrExit(LocalDateTime.now(), String.valueOf(user.getTUI().getID()),user.getTUI().getName());
                                    nextStage = true;
                                }
                                else if (input.equals("3")){
                                    valdes.registerEntryOrExit(LocalDateTime.now(), String.valueOf(user.getTUI().getID()),user.getTUI().getName());
                                    nextStage = true;
                                }
                                else if (input.equals("4")){
                                    espania.registerEntryOrExit(LocalDateTime.now(), String.valueOf(user.getTUI().getID()),user.getTUI().getName());
                                    nextStage = true;
                                }
                                else if (input.equals("5")){
                                    simMenu = false;
                                    nextStage = false;
                                }
                                if (nextStage){
                                    simInsideTheCampus = true;
                                    while (simInsideTheCampus){
                                        nextStage = false;
                                        ///////////// the user was able to enter the university throught any entrance
                                        System.out.println(simulationMessageInsideCampus);
                                        keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                        input = keyboardInput.readLine();
                                        while (!input.equals("1") && !input.equals("2")){
                                            System.out.println("Por favor ingrese una opcion valida");
                                            keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                            input = keyboardInput.readLine();
                                        }
                                        if (input.equals("1")){
                                            ///////////// the user goes to some sports court
                                            System.out.println(simulationSelectSportsCourtMessage);
                                            keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                            input = keyboardInput.readLine();
                                            while (!input.equals("1") && !input.equals("2") && !input.equals("3") && !input.equals("4")){
                                                System.out.println("Por favor ingrese una opcion valida");
                                                keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                                input = keyboardInput.readLine();
                                            }
                                            if (input.equals("1")){
                                                System.out.println(torre.markAsistence(String.valueOf(user.getTUI().getID()), LocalDateTime.now(), "c5x5", 10, 1500));
                                            }
                                            else if (input.equals("2")){
                                                System.out.println(torre.markAsistence(String.valueOf(user.getTUI().getID()), LocalDateTime.now(), "c7x7", 10, 1500));
                                            }
                                            else if (input.equals("3")){
                                                System.out.println(torre.markAsistence(String.valueOf(user.getTUI().getID()), LocalDateTime.now(), "cpasto", 10, 1500));
                                            }
                                        }
                                        else if (input.equals("2")){
                                            ///////////// the user goes to an entrance with the objective to get outside the campus
                                            System.out.println(simulationLeavingCampusMenuMessage);
                                            keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                            input = keyboardInput.readLine();
                                            nextStage = false;
                                            while (!input.equals("1") && !input.equals("2") && !input.equals("3") && !input.equals("4") && !input.equals("5")){
                                                System.out.println("Por favor ingrese una opcion valida");
                                                keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                                input = keyboardInput.readLine();
                                            }
                                            if (input.equals("1")){
                                                placeres.registerEntryOrExit(LocalDateTime.now(), String.valueOf(user.getTUI().getID()),user.getTUI().getName());
                                                nextStage = true;
                                            }
                                            else if (input.equals("2")){
                                                portales.registerEntryOrExit(LocalDateTime.now(), String.valueOf(user.getTUI().getID()),user.getTUI().getName());
                                                nextStage = true;
                                            }
                                            else if (input.equals("3")){
                                                valdes.registerEntryOrExit(LocalDateTime.now(), String.valueOf(user.getTUI().getID()),user.getTUI().getName());
                                                nextStage = true;
                                            }
                                            else if (input.equals("4")){
                                                espania.registerEntryOrExit(LocalDateTime.now(), String.valueOf(user.getTUI().getID()),user.getTUI().getName());
                                                nextStage = true;
                                            }
                                            else if (input.equals("5")){
                                                nextStage = false;
                                            }
                                            if (nextStage){
                                                nextStage = false;
                                                simInsideTheCampus = false;
                                            }
                                        }
                                    }

                                }
                            }
                        }
                        else System.out.println("Por favor ingrese un ID existente");
                    }
                    else if (input.equals("2")){info=Stage3.Register(1); 
                        System.out.println(info);};
                    if (input.equals("3")) simLogMenu = false;
                }
            }
            else if (input.equals("3")) mainMenu = false; 
        }
    }
    
    /**
     * @param menu String: The ID of the user
     * @return String[]: This method will return an array with all the lines that have the ID on an specific field
     */
    public static String Register(int menu) throws IOException {
        ///////////// this is the page's Register
        String out = "Registro Satisfactorio\n";
        BufferedReader keyboardInput;
        String input;
        String name;
        String fecha;
        String delimiter = "/";
        String[] temp;
        int dd,mm,aaaa;
        String mail;
        //boolean RegMenu = false;
        person user;
        databaseManager TUI_database = new databaseManager("bases de datos/TUI dataBase");

        System.out.println("Ingrese el nuevo ID");
        keyboardInput = new BufferedReader(new InputStreamReader(System.in));
        input = keyboardInput.readLine();

        if (TUI_database.lookForID(input).length>0){
            ///////////// if login is successful
            System.out.println("La ID ingresada ya existe");
            user = new person(TUI_database.pullInfo(input)[1],8,8,1994,5000,new TUI(TUI_database.pullInfo(input)[1], 1, Integer.valueOf(input)));
            System.out.println("Usuario es: "+user.getName()+", "+ user.getTUI());
        }
        else{
            System.out.println("Por favor ingrese su nombre");
            keyboardInput = new BufferedReader(new InputStreamReader(System.in));
            name = keyboardInput.readLine();
            System.out.println("Su nombre es: "+name);
            System.out.println("Por favor ingrese su fecha de nacimiento: (dd/mm/aaaa)");
            keyboardInput = new BufferedReader(new InputStreamReader(System.in));
            fecha = keyboardInput.readLine();
            temp = fecha.split(delimiter);
            dd = Integer.parseInt(temp[0]);
            mm = Integer.parseInt(temp[1]);
            aaaa = Integer.parseInt(temp[2]);
            System.out.println("La fecha es: "+dd+" del "+mm+" de "+aaaa);
            System.out.println("Por favor ingrese su correo:");
            keyboardInput = new BufferedReader(new InputStreamReader(System.in));
            mail = keyboardInput.readLine();
            System.out.println("El correo es: "+mail);
            user = new person(TUI_database.pullInfo(input)[0],dd,mm,aaaa,0);
            String[] data = new String[] {input,name,mail,"0","5000","0"};
            TUI_database.pushInfo(data);
    }
        return out;
    }
}