import java.sql.Date;
import java.time.*;

class person {
    /////////////////////////////// Parameters
    private String name;
    private int birthDay;
    private int birthMonth;
    private int birthYear;
    private long cash;
    private TUI TUIcard;

    /////////////////////////////// Inicializators
    public person(String nombre, int dia, int mes, int anio) {
        this.name = nombre;
        this.birthDay = dia;
        this.birthMonth = mes;
        this.birthYear = anio;
        this.cash = 0;
        this.TUIcard = null;
    }

    public person(String nombre, int dia, int mes, int anio, long efectivo) {
        this.name = nombre;
        this.birthDay = dia;
        this.birthMonth = mes;
        this.birthYear = anio;
        this.cash = efectivo;
        this.TUIcard = null;
    }

    public person(String nombre, int dia, int mes, int anio, long efectivo, TUI tarjeta) {
        this.name = nombre;
        this.birthDay = dia;
        this.birthMonth = mes;
        this.birthYear = anio;
        this.cash = efectivo;
        this.TUIcard = tarjeta;
    }

    /////////////////////////////// Methods
    public int getAge(LocalDateTime now) {
        int yearDifference;
        yearDifference = now.getYear() - this.birthYear;
        if (now.getMonthValue() < this.birthMonth)
            yearDifference--;
        if (now.getMonthValue() == this.birthMonth && now.getDayOfMonth() < this.birthDay)
            yearDifference--;
        return yearDifference;
    }
    public TUI getTUI() {
        return TUIcard;
    }
    public String getName() {
        return this.name;
    }
}